function FeedDownloader(feedtype, callback){
	var _self = this;
	
	this.active = false;
	this.callback = callback;
	this.timeout = null;
	
	this.connection = new XMLHttpRequest();
	
	this.timerDelay = null
	
	this.feedtype = feedtype;
		
	if(feedtype == "popular")
		this.op = "GetPopularList";
	else if(feedtype == "mgu")
		this.op = "GetScheduledRecordingsAndFavoritesList";
	else if(feedtype == "favorites")
		this.op = "GetFavoriteList";
	else if(feedtype == "mgs")
		this.op = "GetSeriesRecordingList";
	else if(feedtype == "epg")
		this.op = "GetEpg";
	else if(feedtype == "channels")
		this.op = "GetChannelList";
	else if(feedtype == "devices")
		this.op = "GetDeviceList";
	else if(feedtype == "recommended")
		this.op = "GetRecommendedList";
	else if(feedtype == "update")
		this.op = "CheckForUpdates";
	else if(feedtype == "releaseNotes")
		this.op = "GetReleaseNotes";
	else if(feedtype == "keywords")
		this.op = "GetKeywordRecordingList";
	else if(feedtype == "networks")
		this.op = "GetNetworkList";
}
 
FeedDownloader.prototype.buildURL = function(lastupdate, userInitiated){
	var api_check = hex_sha1(api_secret + 'api_version' + widgetApiVersion + 'application_name' + widgetApplicationName + 'application_version' + widgetVersion + 'auth_token' + ath.authToken + 'format' + 'json' + 'user_initiated' + userInitiated);
	this.address = host_url + '?op=' + this.op + '&api_key=' + api_key + '&api_version=' + widgetApiVersion + '&application_name=' + widgetApplicationName + '&application_version=' + widgetVersion + '&auth_token=' + ath.authToken + '&format=' + 'json' + '&user_initiated=' + userInitiated + '&api_check=' + api_check; 
	if(this.op == "GetEpg"){
		api_check = hex_sha1(api_secret + 'api_version' + widgetApiVersion + 'application_name' + widgetApplicationName + 'application_version' + widgetVersion + 'auth_token' + ath.authToken + 'format' + 'json' + 'last_update' + lastupdate + 'user_initiated' + userInitiated);
		this.address = host_url + '?op=' + 'GetEpg' + '&api_key=' + api_key + '&api_version=' + widgetApiVersion + '&application_name=' + widgetApplicationName + '&application_version=' + widgetVersion + '&auth_token=' + ath.authToken + '&format=' + 'json' + '&last_update=' + lastupdate + '&user_initiated=' + userInitiated + '&api_check=' + api_check;
	}
	if(this.op == "CheckForUpdates"){
		this.address = update_url + "?op=get_version&number=18"
	}
	if(this.op == "GetReleaseNotes"){
		this.address = update_url + "?op=get_release_notes&number=18"
	}
    DEBUGLOG("FeedDownloader.js[53]: this.address: " + this.address);
}

FeedDownloader.prototype.fetchURL = function(delay){
	var _self = this;
	if(delay){
		setTimeout(function(){ _self.doFetch(); }, 3000);
	} else {
		this.doFetch();	
	}
}

	
FeedDownloader.prototype.doFetch = function(){
//    DEBUGLOG("doFetch: feedtype: " + this.feedtype);

	if(this.active)
		return;
	
	this.active = true;
	var _self = this;

	if(initialSetupComplete){
		if(this.feedtype == "epg")
			rmtQueue.setSubActive(0)
		else if(this.feedtype == "popular")
			rmtQueue.setSubActive(1)
		else if(this.feedtype == "mgu")
			rmtQueue.setSubActive(2)
		else if(this.feedtype == "mgs")
			rmtQueue.setSubActive(3)
		else if(this.feedtype == "recommended")
			rmtQueue.setSubActive(4)
		else if(this.feedtype == "update" || this.feedtype == "releaseNotes")
			rmtQueue.setSubActive(5)
		else if(this.feedtype == "favorites")
			rmtQueue.setSubActive(6)
		else if(this.feedtype == "devices")
			rmtQueue.setSubActive(7)
		else if(this.feedtype == "keywords")
			rmtQueue.setSubActive(8)
		else if(this.feedtype == "networks")
			rmtQueue.setSubActive(9)
	}
	
	setTimeout(function(){ _self.abort(); }, 240000);
	this.connection.onreadystatechange = function(){ _self.stateChange(); };
//    DEBUGLOG("Sending: " + encodeURI(this.address));
	this.connection.open( "GET", encodeURI(this.address), true);
	this.connection.send();
}

FeedDownloader.prototype.abort = function(){
	this.active = false;
	this.connection.abort();
}

FeedDownloader.prototype.stateChange = function(){
	if(this.connection.readyState == 4){
		clearTimeout(this.timeout);
		this.timeout = null;
		this.active = false;
		if(!upd.criticalUpdateAvailable)
			this.callback(this.connection.responseText);
			
//        DEBUGLOG("feedtype: " + this.feedtype + " complete.");

		if(!initialSetupComplete){
			intialLoadComplete(this.feedtype);	
		} else {
			if(this.feedtype == "epg")
				rmtQueue.setSubInactive(0)
			else if(this.feedtype == "popular")
				rmtQueue.setSubInactive(1)
			else if(this.feedtype == "mgu")
				rmtQueue.setSubInactive(2)
			else if(this.feedtype == "mgs")
				rmtQueue.setSubInactive(3)
			else if(this.feedtype == "recommended")
				rmtQueue.setSubInactive(4)
			else if(this.feedtype == "update" || this.feedtype == "releaseNotes")
				rmtQueue.setSubInactive(5)
			else if(this.feedtype == "favorites")
				rmtQueue.setSubInactive(6)
			else if(this.feedtype == "devices")
				rmtQueue.setSubInactive(7)
			else if(this.feedtype == "keywords")
				rmtQueue.setSubInactive(8)
			else if(this.feedtype == "networks")
				rmtQueue.setSubInactive(9)
		}
	}
}
